import { Callback } from "./tinify/compat";
import Client from "./tinify/Client";
import Result from "./tinify/Result";
import ResultMeta from "./tinify/ResultMeta";
import Source from "./tinify/Source";
import { Error, AccountError, ClientError, ServerError, ConnectionError } from "./tinify/Error";
declare class Tinify {
    default: this;
    compressionCount?: number;
    Client: typeof Client;
    Source: typeof Source;
    Result: typeof Result;
    ResultMeta: typeof ResultMeta;
    Error: typeof Error;
    AccountError: typeof AccountError;
    ClientError: typeof ClientError;
    ServerError: typeof ServerError;
    ConnectionError: typeof ConnectionError;
    set key(key: string);
    set appIdentifier(appIdentifier: string);
    set proxy(proxy: string);
    get client(): Client;
    fromFile(path: string): Source;
    fromBuffer(data: string | Uint8Array): Source;
    fromUrl(url: string): Source;
    validate(): Promise<void>;
    validate(callback: Callback): void;
}
declare const _default: Tinify;
export default _default;
